n = 20; %keep n and m in this ratio.
m = 12;
x = [0:1/(n-1):1];
y = [0:0.6/(m-1):0.6];
[xx,yy] = meshgrid(x,y);

intrx = xx(2:end-1, 2:end-1);
intry = yy(2:end-1, 2:end-1);
bdryx = [x, repmat([0,1],1,m-2), x];
bdryy = [repmat(0.6,1,n), repmat(y(2:end-1)',1,2)'(:)', repmat(0,1,n)];
nrmlx = [repmat(0,size(x)), repmat([-1,1],1,m-2), repmat(0,size(x))];
nrmly = [repmat(1,size(x)), repmat([0,0],1,m-2), repmat(-1,size(x))];

interior = [intrx(:), intry(:)];
boundary = [bdryx(:), bdryy(:)];
normals = [boundary, nrmlx(:), nrmly(:)];
save intr.v interior;
save bdry.v boundary;
save nrml.v normals;

%% Now define the domain decomposition.
i = 1;
subxx_s{i} = xx(:,1:15);
subyy_s{i} = yy(:,1:15);
intrx_s{i} = subxx_s{i}(2:end-1, 2:end-1);
intry_s{i} = subyy_s{i}(2:end-1, 2:end-1);
bdryx_s{i} = [subxx_s{i}(1,:), subxx_s{i}(2:end-1,end)', ...
	      subxx_s{i}(end, end:-1:1), subxx_s{i}(end-1:-1:2,1)'];
bdryy_s{i} = [subyy_s{i}(1,:), subyy_s{i}(2:end-1,end)', ...
	      subyy_s{i}(end, end:-1:1), subyy_s{i}(end-1:-1:2,1)'];

nrmlx_s{i} = [repmat( 0,size(subxx_s{i}(1,:))), ...
	      repmat( 1,size(subxx_s{i}(2:end-1,end)')), ...
	      repmat( 0,size(subxx_s{i}(end, end:-1:1))), ...
	      repmat(-1,size(subxx_s{i}(end-1:-1:2,1)'))];
nrmly_s{i} = [repmat( 1,size(subyy_s{i}(1,:))), ...
	      repmat( 0,size(subyy_s{i}(2:end-1,end)')), ...
	      repmat(-1,size(subyy_s{i}(end, end:-1:1))), ...
	      repmat( 0,size(subyy_s{i}(end-1:-1:2,1)))'];


a = [intrx_s{i}(:), intry_s{i}(:)];
b = [bdryx_s{i}(:), bdryy_s{i}(:)];
c = [b, nrmlx_s{i}(:), nrmly_s{i}(:)];

is = num2str(i);
save(strcat("intr",is,".v"),"a");
save(strcat("bdry",is,".v"),"b");
save(strcat("nrml",is,".v"),"c");
%%Again
i = 2;
subxx_s{i} = xx(:,5:20);
subyy_s{i} = yy(:,5:20);
intrx_s{i} = subxx_s{i}(2:end-1, 2:end-1);
intry_s{i} = subyy_s{i}(2:end-1, 2:end-1);
bdryx_s{i} = [subxx_s{i}(1,:), subxx_s{i}(2:end-1,end)', ...
	      subxx_s{i}(end, end:-1:1), subxx_s{i}(end-1:-1:2,1)'];
bdryy_s{i} = [subyy_s{i}(1,:), subyy_s{i}(2:end-1,end)', ...
	      subyy_s{i}(end, end:-1:1), subyy_s{i}(end-1:-1:2,1)'];

nrmlx_s{i} = [repmat( 0,size(subxx_s{i}(1,:))), ...
	      repmat( 1,size(subxx_s{i}(2:end-1,end)')), ...
	      repmat( 0,size(subxx_s{i}(end, end:-1:1))), ...
	      repmat(-1,size(subxx_s{i}(end-1:-1:2,1)'))];
nrmly_s{i} = [repmat( 1,size(subyy_s{i}(1,:))), ...
	      repmat( 0,size(subyy_s{i}(2:end-1,end)')), ...
	      repmat(-1,size(subyy_s{i}(end, end:-1:1))), ...
	      repmat( 0,size(subyy_s{i}(end-1:-1:2,1)))'];


a = [intrx_s{i}(:), intry_s{i}(:)];
b = [bdryx_s{i}(:), bdryy_s{i}(:)];
c = [b, nrmlx_s{i}(:), nrmly_s{i}(:)];

is = num2str(i);
save(strcat("intr",is,".v"),"a");
save(strcat("bdry",is,".v"),"b");
save(strcat("nrml",is,".v"),"c");
